/*
 * Linux Intrusion Detectino System for Linux Security Modules project
 *
 * Copyright (C) 2002 Huagang Xie (xie@www.lids.org) 
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *  Feb 4th, 2002, Huagang, Initial the project  
 *	
 */

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/security.h>
#include <linux/netfilter.h>
#include <linux/netlink.h>
#include <linux/lids.h>
#include <linux/lidsext.h>
#include <linux/lidsif.h>

static int lids_sethostname (char *hostname)
{
	return 0;
}

static int lids_setdomainname (char *domainname)
{
	return 0;
}

static int lids_reboot (unsigned int cmd)
{
	return 0;
}

static int lids_ioperm (unsigned long from, unsigned long num, int turn_on)
{
	return 0;
}

static int lids_iopl (unsigned int old, unsigned int level)
{
	return 0;
}

static int lids_ptrace (struct task_struct *parent, struct task_struct *child)
{
	return 0;
}

static int lids_capget (struct task_struct *target, kernel_cap_t * effective,
			 kernel_cap_t * inheritable, kernel_cap_t * permitted)
{
	return 0;
}

static int lids_capset_check (struct task_struct *target,
			       kernel_cap_t * effective,
			       kernel_cap_t * inheritable,
			       kernel_cap_t * permitted)
{
	return 0;
}

static void lids_capset_set (struct task_struct *target,
			      kernel_cap_t * effective,
			      kernel_cap_t * inheritable,
			      kernel_cap_t * permitted)
{
	return;
}

static int lids_acct (struct file *file)
{
	return 0;
}

static int lids_capable (struct task_struct *tsk, int cap)
{
	if(lids_load && lids_local_load) {
		return lids_check_capable(tsk,cap,1);
	}
/* the original one */
	if (cap_is_fs_cap (cap) ? tsk->fsuid == 0 : tsk->euid == 0)
		/* capability granted */
		return 0;

	/* capability denied */
	return -EPERM;
}

static int lids_sysctl (ctl_table * table, int op)
{
	return 0;
}

static int lids_sys_security (unsigned int id, unsigned int call,
			       unsigned long *args)
{
	return -ENOSYS;
}

static int lids_swapon (struct swap_info_struct *swap)
{
	return 0;
}

static int lids_swapoff (struct swap_info_struct *swap)
{
	return 0;
}

static int lids_nfsservctl (int cmd, struct nfsctl_arg *arg)
{
	return 0;
}

static int lids_quotactl (int cmds, int type, int id, struct super_block *sb)
{
	return 0;
}

static int lids_quota_on (struct file *f)
{
	return 0;
}

static int lids_bdflush (int func, long data)
{
	return 0;
}

static int lids_syslog (int type)
{
	return 0;
}

static int lids_netlink_send (struct sk_buff *skb)
{
	if (current->euid == 0)
		cap_raise (NETLINK_CB (skb).eff_cap, CAP_NET_ADMIN);
	else
		NETLINK_CB (skb).eff_cap = 0;
	return 0;
}

static int lids_netlink_recv (struct sk_buff *skb)
{
	if (!cap_raised (NETLINK_CB (skb).eff_cap, CAP_NET_ADMIN))
		return -EPERM;
	return 0;
}

static int lids_binprm_alloc_security (struct linux_binprm *bprm)
{
	return 0;
}

static void lids_binprm_free_security (struct linux_binprm *bprm)
{
	return;
}

static void lids_binprm_compute_creds (struct linux_binprm *bprm)
{
	return;
}

static int lids_binprm_set_security (struct linux_binprm *bprm)
{
	return 0;
}

static int lids_binprm_check_security (struct linux_binprm *bprm)
{
	/* do the do_execve here */
	if(copy_lids_acls(bprm)) 
		return -1;
	return 0;
}

static int lids_sb_alloc_security (struct super_block *sb)
{
	return 0;
}

static void lids_sb_free_security (struct super_block *sb)
{
	return;
}

static int lids_sb_statfs (struct super_block *sb)
{
	return 0;
}

static int lids_mount (char *dev_name, struct nameidata *nd, char *type,
			unsigned long flags, void *data)
{
	return 0;
}

static int lids_check_sb (struct vfsmount *mnt, struct nameidata *nd)
{
	return 0;
}

static int lids_umount (struct vfsmount *mnt, int flags)
{
	return 0;
}

static void lids_umount_close (struct vfsmount *mnt)
{
	return;
}

static void lids_umount_busy (struct vfsmount *mnt)
{
	return;
}

static void lids_post_remount (struct vfsmount *mnt, unsigned long flags,
				void *data)
{
	return;
}

static void do_lids_setup(void)
{
	/* init the ids file system */
	/* this lids_load need to get lids = on/off from paramerter */
	lids_load=1;
	lids_local_on=1;
	lids_flags=0;
	lids_flag_raise(lids_flags,LIDS_FLAGS_LIDS_LOCAL_ON);
	
	if (lids_load) lids_flag_raise(lids_flags,LIDS_FLAGS_LIDS_ON);

	printk("Linux Intrusion Detection System %s %s \n",LIDS_VERSION,lids_load==1?"started":"not started");
	if(lids_load) {
#ifdef CONFIG_LIDS_SA_THROUGH_NET
		lids_klids_init();
#endif
#ifdef CONFIG_LIDS_PORT_SCAN_DETECTOR
		lids_port_scanner_detector_init();
#endif
#ifdef CONFIG_LIDS_ALLOW_SWITCH
		lids_sysctl_init();
#endif
		lids_init();
	}
}

static void lids_post_mountroot (void)
{
	do_lids_setup();
	return;
}

static void lids_post_addmount (struct vfsmount *mnt, struct nameidata *nd)
{
	return;
}

static int lids_inode_alloc_security (struct inode *inode)
{
	return 0;
}

static void lids_inode_free_security (struct inode *inode)
{
	return;
}

static int lids_inode_create (struct inode *inode, struct dentry *dentry,
			       int mask)
{
	return 0;
}

static void lids_inode_post_create (struct inode *inode, struct dentry *dentry,
				     int mask)
{
	return;
}

static int lids_inode_link (struct dentry *old_dentry, struct inode *inode,
			     struct dentry *new_dentry)
{
	return 0;
}

static void lids_inode_post_link (struct dentry *old_dentry,
				   struct inode *inode,
				   struct dentry *new_dentry)
{
	return;
}

static int lids_inode_unlink (struct inode *inode, struct dentry *dentry)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to unlink %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static int lids_inode_symlink (struct inode *inode, struct dentry *dentry,
				const char *name)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to symlink %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static void lids_inode_post_symlink (struct inode *inode,
				      struct dentry *dentry, const char *name)
{
	return;
}

static int lids_inode_mkdir (struct inode *inode, struct dentry *dentry,
			      int mask)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to mkdir %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static void lids_inode_post_mkdir (struct inode *inode, struct dentry *dentry,
				    int mask)
{
	return;
}

static int lids_inode_rmdir (struct inode *inode, struct dentry *dentry)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to rmdir %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static int lids_inode_mknod (struct inode *inode, struct dentry *dentry,
			      int major, dev_t minor)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to mknod %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static void lids_inode_post_mknod (struct inode *inode, struct dentry *dentry,
				    int major, dev_t minor)
{
	return;
}

static int lids_inode_rename (struct inode *old_inode,
			       struct dentry *old_dentry,
			       struct inode *new_inode,
			       struct dentry *new_dentry)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(old_dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to rename from %.1024s",old_dentry->d_iname);
			return -EPERM;
                }
                if (lids_check_base(new_dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to rename to %.1024s",new_dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static void lids_inode_post_rename (struct inode *old_inode,
				     struct dentry *old_dentry,
				     struct inode *new_inode,
				     struct dentry *new_dentry)
{
	return;
}

static int lids_inode_readlink (struct dentry *dentry)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_READONLY)) {
                        lids_security_alert("Attempt to readlink %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static int lids_inode_follow_link (struct dentry *dentry,
				    struct nameidata *nameidata)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_READONLY)) {
                        lids_security_alert("Attempt to followlink %.1024s",dentry->d_iname);
			return -EPERM;
                }
        }
	return 0;
}

static int lids_inode_permission (struct inode *inode, int mask)
{
	if(lids_load && lids_local_load ) {
		if(lids_check_hidden_inode(inode->i_ino, inode->i_dev)) {
			if(lids_check_acl_inode(inode,LIDS_READONLY,0)) {
				return -EPERM;
			}
		}
	}
	return 0;
}

static int lids_inode_revalidate (struct dentry *inode)
{
	return 0;
}

static int lids_inode_setattr (struct dentry *dentry, struct iattr *iattr)
{
        if( lids_load && lids_local_load) {
                if (lids_check_base(dentry,LIDS_WRITE)) {
                        lids_security_alert("Attempt to fchmod %s to mode %o",dentry->d_iname, iattr->ia_mode);
			return -EPERM;
                }
        }
	return 0;
}

static int lids_inode_stat (struct inode *inode)
{
	return 0;
}

static void lids_post_lookup (struct inode *ino, struct dentry *d)
{
	return;
}

static void lids_delete (struct inode *ino)
{
	return;
}

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,2)
static int lids_inode_setxattr (struct dentry *dentry, char *name, void *value,
				size_t size, int flags)
{
	return 0;
}

static int lids_inode_getxattr (struct dentry *dentry, char *name)
{
	return 0;
}

static int lids_inode_listxattr (struct dentry *dentry)
{
	return 0;
}

static int lids_inode_removexattr (struct dentry *dentry, char *name)
{
	return 0;
}
#endif

static int lids_file_permission (struct file *file, int mask)
{
	int error = 0;

	if(lids_load && lids_local_load ) {

       		if( (mask&MAY_APPEND)) {
          		if(mask & O_APPEND) {
                		error = lids_check_base(file->f_dentry,LIDS_APPEND);
			}
			if(error) {
                		lids_security_alert("Attempt to open %.1024s  appending,mask=%d",file->f_dentry->d_iname, mask);
              			error=-EPERM;
			}
		}
        	else if( (mask&MAY_WRITE)){
               		error = lids_check_base(file->f_dentry,LIDS_WRITE);
			if(error) {
                 		lids_security_alert("Attempt to open %.1024s for writing,mask=%d",file->f_dentry->d_iname,mask);
              			error=-EPERM;
			}
		}
        	else if( (mask&MAY_EXEC)){
			error = lids_check_base(file->f_dentry,LIDS_READONLY);
			if(error) {
                 		lids_security_alert("Attempt to for reading %.1024s ,mask=%d",file->f_dentry->d_iname, mask);
				error = -ENOENT;
				}
			
		}
	}
	return error;
}

static int lids_file_alloc_security (struct file *file)
{
	return 0;
}

static void lids_file_free_security (struct file *file)
{
	return;
}

static int lids_file_llseek (struct file *file)
{
	return 0;
}

static int lids_file_ioctl (struct file *file, unsigned int command,
			     unsigned long arg)
{
	return 0;
}

static int lids_file_mmap (struct file *file, unsigned long prot,
			    unsigned long flags)
{
	return 0;
}

static int lids_file_mprotect (struct vm_area_struct *vma, unsigned long prot)
{
	return 0;
}

static int lids_file_lock (struct file *file, unsigned int cmd, int blocking)
{
	return 0;
}

static int lids_file_fcntl (struct file *file, unsigned int cmd,
			     unsigned long arg)
{
	return 0;
}

static int lids_file_set_fowner (struct file *file)
{
	return 0;
}

static int lids_file_send_sigiotask (struct task_struct *tsk,
				      struct fown_struct *fown, int fd,
				      int reason)
{
	return 0;
}

static int lids_file_receive (struct file *file)
{
	return 0;
}


static int lids_task_create (unsigned long clone_flags)
{
	return 0;
}

static int lids_task_alloc_security (struct task_struct *p)
{
	if(fork_lids_sys_acl(p)) 
		return -1;
	return 0;
}

static void lids_task_free_security (struct task_struct *p)
{
	struct lids_sys_acl *tsk_sys_acl;
	task_lock(p);
	tsk_sys_acl=p->security;
	p->security = NULL;
	task_unlock(p);

	if(tsk_sys_acl) {
		LIDS_DBG(__FUNCTION__":current->pid %d p->pid %d ppid %d\n", current->pid, p->pid, p->p_pptr->pid); 
		lids_free_sys_acl(tsk_sys_acl);
	}
	return;
}

static int lids_task_setuid (uid_t id0, uid_t id1, uid_t id2, int flags)
{
	return 0;
}

static int lids_task_post_setuid (uid_t id0, uid_t id1, uid_t id2, int flags)
{
	return 0;
}

static int lids_task_setgid (gid_t id0, gid_t id1, gid_t id2, int flags)
{
	return 0;
}

static int lids_task_setpgid (struct task_struct *p, pid_t pgid)
{
	return 0;
}

static int lids_task_getpgid (struct task_struct *p)
{
	return 0;
}

static int lids_task_getsid (struct task_struct *p)
{
	return 0;
}

static int lids_task_setgroups (int gidsetsize, gid_t * grouplist)
{
	return 0;
}

static int lids_task_setnice (struct task_struct *p, int nice)
{
	return 0;
}

static int lids_task_setrlimit (unsigned int resource, struct rlimit *new_rlim)
{
	return 0;
}

static int lids_task_setscheduler (struct task_struct *p, int policy,
				    struct sched_param *lp)
{
	return 0;
}

static int lids_task_getscheduler (struct task_struct *p)
{
	return 0;
}

static int lids_task_wait (struct task_struct *p)
{
	return 0;
}

static int lids_task_kill (struct task_struct *p, struct siginfo *info,
			    int sig)
{
 	if(lids_check_task_kill(p,info,sig)) 
 		return -EPERM;
	return 0;
}

static int lids_task_prctl (int option, unsigned long arg2, unsigned long arg3,
			     unsigned long arg4, unsigned long arg5)
{
	return 0;
}

static void lids_task_kmod_set_label (void)
{
	return;
}

static unsigned int lids_ip_preroute_first (unsigned int hooknum,
					     struct sk_buff **pskb,
					     const struct net_device *in,
					     const struct net_device *out,
					     int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_preroute_last (unsigned int hooknum,
					    struct sk_buff **pskb,
					    const struct net_device *in,
					    const struct net_device *out,
					    int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_input_first (unsigned int hooknum,
					  struct sk_buff **pskb,
					  const struct net_device *in,
					  const struct net_device *out,
					  int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_input_last (unsigned int hooknum,
					 struct sk_buff **pskb,
					 const struct net_device *in,
					 const struct net_device *out,
					 int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_forward_first (unsigned int hooknum,
					    struct sk_buff **pskb,
					    const struct net_device *in,
					    const struct net_device *out,
					    int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_forward_last (unsigned int hooknum,
					   struct sk_buff **pskb,
					   const struct net_device *in,
					   const struct net_device *out,
					   int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_output_first (unsigned int hooknum,
					   struct sk_buff **pskb,
					   const struct net_device *in,
					   const struct net_device *out,
					   int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_output_last (unsigned int hooknum,
					  struct sk_buff **pskb,
					  const struct net_device *in,
					  const struct net_device *out,
					  int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_postroute_first (unsigned int hooknum,
					      struct sk_buff **pskb,
					      const struct net_device *in,
					      const struct net_device *out,
					      int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static unsigned int lids_ip_postroute_last (unsigned int hooknum,
					     struct sk_buff **pskb,
					     const struct net_device *in,
					     const struct net_device *out,
					     int (*okfn) (struct sk_buff *))
{
	return NF_ACCEPT;
}

static void lids_ip_fragment (struct sk_buff *newskb,
			       const struct sk_buff *oldskb)
{
	return;
}

static int lids_ip_defragment (struct sk_buff *skb)
{
	return 0;
}

static void lids_ip_decapsulate (struct sk_buff *skb)
{
	return;
}

static void lids_ip_encapsulate (struct sk_buff *skb)
{
	return;
}

static int lids_ip_decode_options (struct sk_buff *skb, const char *optptr,
				    unsigned char **pp_ptr)
{
	if (!skb && !capable (CAP_NET_RAW)) {
		(const unsigned char *) *pp_ptr = optptr;
		return -EPERM;
	}
	return 0;
}

static void lids_netdev_unregister (struct net_device *dev)
{
	return;
}

static int lids_socket_create (int family, int type, int protocol)
{
	return 0;
}

static void lids_socket_post_create (struct socket *sock, int family, int type,
				      int protocol)
{
	return;
}

static int lids_socket_bind (struct socket *sock, struct sockaddr *address,
			      int addrlen)
{
	return 0;
}

static int lids_socket_connect (struct socket *sock, struct sockaddr *address,
				 int addrlen)
{
	return 0;
}

static int lids_socket_listen (struct socket *sock, int backlog)
{
	return 0;
}

static int lids_socket_accept (struct socket *sock, struct socket *newsock)
{
	return 0;
}

static int lids_socket_sendmsg (struct socket *sock, struct msghdr *msg,
				 int size)
{
	return 0;
}

static int lids_socket_recvmsg (struct socket *sock, struct msghdr *msg,
				 int size, int flags)
{
	return 0;
}

static int lids_socket_getsockname (struct socket *sock)
{
	return 0;
}

static int lids_socket_getpeername (struct socket *sock)
{
	return 0;
}

static int lids_socket_setsockopt (struct socket *sock, int level, int optname)
{
	return 0;
}

static int lids_socket_getsockopt (struct socket *sock, int level, int optname)
{
	return 0;
}

static int lids_socket_shutdown (struct socket *sock, int how)
{
	return 0;
}

static int lids_sock_rcv_skb (struct sock *sk, struct sk_buff *skb)
{
	return 0;
}

static int lids_socket_unix_stream_connect (struct socket *sock,
					     struct socket *other)
{
	return 0;
}

static int lids_socket_unix_may_send (struct socket *sock,
				       struct socket *other)
{
	return 0;
}

static int lids_module_create_module (const char *name_user, size_t size)
{
	return 0;
}

static int lids_module_init_module (struct module *mod_user)
{
	return 0;
}

static int lids_module_delete_module (const struct module *mod)
{
	return 0;
}

static int lids_ipc_permission (struct kern_ipc_perm *ipcp, short flag)
{
	return 0;
}

static int lids_ipc_getinfo (int id, int cmd)
{
	return 0;
}

static int lids_msg_msg_alloc_security (struct msg_msg *msg)
{
	return 0;
}

static void lids_msg_msg_free_security (struct msg_msg *msg)
{
	return;
}

static int lids_msg_queue_alloc_security (struct msg_queue *msq)
{
	return 0;
}

static void lids_msg_queue_free_security (struct msg_queue *msq)
{
	return;
}

static int lids_msg_queue_associate (struct msg_queue *msq, int msqid,
				      int msqflg)
{
	return 0;
}

static int lids_msg_queue_msgctl (struct msg_queue *msq, int msqid, int cmd)
{
	return 0;
}

static int lids_msg_queue_msgsnd (struct msg_queue *msq, struct msg_msg *msg,
				   int msqid, int msgflg)
{
	return 0;
}

static int lids_msg_queue_msgrcv (struct msg_queue *msq, struct msg_msg *msg,
				   struct task_struct *target, long type,
				   int mode)
{
	return 0;
}

static int lids_shm_alloc_security (struct shmid_kernel *shp)
{
	return 0;
}

static void lids_shm_free_security (struct shmid_kernel *shp)
{
	return;
}

static int lids_shm_associate (struct shmid_kernel *shp, int shmid, int shmflg)
{
	return 0;
}

static int lids_shm_shmctl (struct shmid_kernel *shp, int shmid, int cmd)
{
	return 0;
}

static int lids_shm_shmat (struct shmid_kernel *shp, int shmid, char *shmaddr,
			    int shmflg)
{
	return 0;
}

static int lids_sem_alloc_security (struct sem_array *sma)
{
	return 0;
}

static void lids_sem_free_security (struct sem_array *sma)
{
	return;
}

static int lids_sem_associate (struct sem_array *sma, int semid, int semflg)
{
	return 0;
}

static int lids_sem_semctl (struct sem_array *sma, int semid, int cmd)
{
	return 0;
}

static int lids_sem_semop (struct sem_array *sma, int semid,
			    struct sembuf *sops, unsigned nsops, int alter)
{
	return 0;
}

static int lids_skb_alloc_security (struct sk_buff *skb)
{
	return 0;
}

static int lids_skb_clone (struct sk_buff *newskb,
			     const struct sk_buff *oldskb)
{
	return 0;
}

static void lids_skb_copy (struct sk_buff *newskb,
			    const struct sk_buff *oldskb)
{
	return;
}

static void lids_skb_set_owner_w (struct sk_buff *skb, struct sock *sk)
{
	return;
}

static void lids_skb_free_security (struct sk_buff *skb)
{
	return;
}

static int lids_register (const char *name, struct security_operations *ops)
{
	return -EINVAL;
}

static int lids_unregister (const char *name, struct security_operations *ops)
{
	return -EINVAL;
}

static struct binprm_security_ops lids_binprm_ops = {
	alloc_security:	lids_binprm_alloc_security,
	free_security:	lids_binprm_free_security,
	compute_creds:	lids_binprm_compute_creds,
	set_security:	lids_binprm_set_security,
	check_security:	lids_binprm_check_security,
};

static struct super_block_security_ops lids_sb_ops = {
	alloc_security:	lids_sb_alloc_security,
	free_security:	lids_sb_free_security,
	statfs:		lids_sb_statfs,
	mount:		lids_mount,
	check_sb:	lids_check_sb,
	umount:		lids_umount,
	umount_close:	lids_umount_close,
	umount_busy:	lids_umount_busy,
	post_remount:	lids_post_remount,
	post_mountroot:	lids_post_mountroot,
	post_addmount:	lids_post_addmount,
};

static struct inode_security_ops lids_inode_ops = {
	alloc_security:	lids_inode_alloc_security,
	free_security:	lids_inode_free_security,
	create:		lids_inode_create,
	post_create:	lids_inode_post_create,
	link:		lids_inode_link,
	post_link:	lids_inode_post_link,
	unlink:		lids_inode_unlink,
	symlink:	lids_inode_symlink,
	post_symlink:	lids_inode_post_symlink,
	mkdir:		lids_inode_mkdir,
	post_mkdir:	lids_inode_post_mkdir,
	rmdir:		lids_inode_rmdir,
	mknod:		lids_inode_mknod,
	post_mknod:	lids_inode_post_mknod,
	rename:		lids_inode_rename,
	post_rename:	lids_inode_post_rename,
	readlink:	lids_inode_readlink,
	follow_link:	lids_inode_follow_link,
	permission:	lids_inode_permission,
	revalidate:	lids_inode_revalidate,
	setattr:	lids_inode_setattr,
	stat:		lids_inode_stat,
	post_lookup:	lids_post_lookup,
	delete:		lids_delete,
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,2)
	setxattr:	lids_inode_setxattr,
	getxattr:	lids_inode_getxattr,
	listxattr:	lids_inode_listxattr,
	removexattr:	lids_inode_removexattr,
#endif
};

static struct file_security_ops lids_file_ops = {
	permission:	lids_file_permission,
	alloc_security:	lids_file_alloc_security,
	free_security:	lids_file_free_security,
	llseek:		lids_file_llseek,
	ioctl:		lids_file_ioctl,
	mmap:		lids_file_mmap,
	mprotect:	lids_file_mprotect,
	lock:		lids_file_lock,
	fcntl:		lids_file_fcntl,
	set_fowner:	lids_file_set_fowner,
	send_sigiotask:	lids_file_send_sigiotask,
	receive:	lids_file_receive,
};

static struct task_security_ops lids_task_ops = {
	create:		lids_task_create,
	alloc_security:	lids_task_alloc_security,
	free_security:	lids_task_free_security,
	setuid:		lids_task_setuid,
	post_setuid:	lids_task_post_setuid,
	setgid:		lids_task_setgid,
	setpgid:	lids_task_setpgid,
	getpgid:	lids_task_getpgid,
	getsid:		lids_task_getsid,
	setgroups:	lids_task_setgroups,
	setnice:	lids_task_setnice,
	setrlimit:	lids_task_setrlimit,
	setscheduler:	lids_task_setscheduler,
	getscheduler:	lids_task_getscheduler,
	wait:		lids_task_wait,
	kill:		lids_task_kill,
	prctl:		lids_task_prctl,
	kmod_set_label:	lids_task_kmod_set_label,
};

static struct socket_security_ops lids_socket_ops = {
	create:			lids_socket_create,
	post_create:		lids_socket_post_create,
	bind:			lids_socket_bind,
	connect:		lids_socket_connect,
	listen:			lids_socket_listen,
	accept:			lids_socket_accept,
	sendmsg:		lids_socket_sendmsg,
	recvmsg:		lids_socket_recvmsg,
	getsockname:		lids_socket_getsockname,
	getpeername:		lids_socket_getpeername,
	getsockopt:		lids_socket_getsockopt,
	setsockopt:		lids_socket_setsockopt,
	shutdown:		lids_socket_shutdown,
	sock_rcv_skb:		lids_sock_rcv_skb,
	unix_stream_connect:	lids_socket_unix_stream_connect,
	unix_may_send:		lids_socket_unix_may_send,
};

static struct skb_security_ops lids_skb_ops = {
	alloc_security:	lids_skb_alloc_security,
	clone:		lids_skb_clone,
	copy:		lids_skb_copy,
	set_owner_w:	lids_skb_set_owner_w,
	free_security:	lids_skb_free_security,
};

static struct ip_security_ops lids_ip_ops = {
	preroute_first:		lids_ip_preroute_first,
	preroute_last:		lids_ip_preroute_last,
	input_first:		lids_ip_input_first,
	input_last:		lids_ip_input_last,
	forward_first:		lids_ip_forward_first,
	forward_last:		lids_ip_forward_last,
	output_first:		lids_ip_output_first,
	output_last:		lids_ip_output_last,
	postroute_first:	lids_ip_postroute_first,
	postroute_last:		lids_ip_postroute_last,
	fragment:		lids_ip_fragment,
	defragment:		lids_ip_defragment,
	encapsulate:		lids_ip_encapsulate,
	decapsulate:		lids_ip_decapsulate,
	decode_options:		lids_ip_decode_options,
};

static struct netdev_security_ops lids_netdev_ops = {
	unregister:	lids_netdev_unregister,
};

static struct module_security_ops lids_module_ops = {
	create_module:	lids_module_create_module,
	init_module:	lids_module_init_module,
	delete_module:	lids_module_delete_module,

};

static struct ipc_security_ops lids_ipc_ops = {
	permission:	lids_ipc_permission,
	getinfo:	lids_ipc_getinfo,
};

static struct msg_msg_security_ops lids_msg_msg_ops = {
	alloc_security:	lids_msg_msg_alloc_security,
	free_security:	lids_msg_msg_free_security,
};

static struct msg_queue_security_ops lids_msg_queue_ops = {
	alloc_security:	lids_msg_queue_alloc_security,
	free_security:	lids_msg_queue_free_security,
	associate:	lids_msg_queue_associate,
	msgctl:		lids_msg_queue_msgctl,
	msgsnd:		lids_msg_queue_msgsnd,
	msgrcv:		lids_msg_queue_msgrcv,
};

static struct shm_security_ops lids_shm_ops = {
	alloc_security:	lids_shm_alloc_security,
	free_security:	lids_shm_free_security,
	associate:	lids_shm_associate,
	shmctl:		lids_shm_shmctl,
	shmat:		lids_shm_shmat,
};

static struct sem_security_ops lids_sem_ops = {
	alloc_security:	lids_sem_alloc_security,
	free_security:	lids_sem_free_security,
	associate:	lids_sem_associate,
	semctl:		lids_sem_semctl,
	semop:		lids_sem_semop,
};

struct security_operations lids_security_ops = {
	sethostname:		lids_sethostname,
	setdomainname:		lids_setdomainname,
	reboot:			lids_reboot,
	ioperm:			lids_ioperm,
	iopl:			lids_iopl,
	ptrace:			lids_ptrace,
	capget:			lids_capget,
	capset_check:		lids_capset_check,
	capset_set:		lids_capset_set,
	acct:			lids_acct,
	capable:		lids_capable,
	sysctl:			lids_sysctl,
	sys_security:		lids_sys_security,
	swapon:			lids_swapon,
	swapoff:		lids_swapoff,
	nfsservctl:		lids_nfsservctl,
	quotactl:		lids_quotactl,
	quota_on:		lids_quota_on,
	bdflush:		lids_bdflush,
	syslog:			lids_syslog,
	netlink_send:		lids_netlink_send,
	netlink_recv:		lids_netlink_recv,

	bprm_ops:		&lids_binprm_ops,
	sb_ops:			&lids_sb_ops,
	inode_ops:		&lids_inode_ops,
	file_ops:		&lids_file_ops,
	task_ops:		&lids_task_ops,
	socket_ops:		&lids_socket_ops,
	skb_ops:		&lids_skb_ops,
	ip_ops:			&lids_ip_ops,
	ipc_ops:		&lids_ipc_ops,
	netdev_ops:		&lids_netdev_ops,
	module_ops:		&lids_module_ops,
	msg_msg_ops:		&lids_msg_msg_ops,
	msg_queue_ops:		&lids_msg_queue_ops,
	shm_ops:		&lids_shm_ops,
	sem_ops:		&lids_sem_ops,

	register_security:	lids_register,
	unregister_security:	lids_unregister,
};

extern void setup_lids_module(void);

static int __init lids_lsm_init (void)
{
	struct task_struct *p;
	        /* register ourselves with the security framework */
	if (register_security (&lids_security_ops)) {
		printk (KERN_INFO "Failure registering LIDS with the kernel\n");
		return -EINVAL;
	}
	read_lock(&tasklist_lock);
	for_each_task(p) {
		p->security = NULL;
	}
	read_unlock(&tasklist_lock);
#ifdef MODULE
	printk(KERN_NOTICE "Setting up LIDS...\n");
	do_lids_setup();
	printk(KERN_NOTICE "Finished setting up LIDS.\n");
#endif
	printk(KERN_INFO "Linux Intrusion Detection System initialized\n");
	return 0;
}

static void __exit lids_lsm_exit (void)
{
	struct task_struct *p;
	if (unregister_security (&lids_security_ops)) {
		printk(KERN_INFO "Failure unregistering LIDS with the kernel\n");
	}
	lids_load = 0;
#ifdef CONFIG_LIDS_SA_THROUGH_NET
	lids_klids_stop();
#endif
	lids_sysctl_reset();
	read_lock(&tasklist_lock);
	for_each_task(p) {
		/* may need to release the p->security here */
		lids_task_free_security(p);
	}
	read_unlock(&tasklist_lock);
	printk(KERN_INFO "Linux Intrusion Detection System Quit\n");
}

module_init (lids_lsm_init);
module_exit (lids_lsm_exit);

MODULE_AUTHOR("Huagang XIE");
MODULE_DESCRIPTION("Linux Intrusion Detection Module");
MODULE_LICENSE("GPL");
